<?xml version="1.0" encoding="UTF-8"?>

<cfsSimulation xmlns="http://www.cfs++.org/simulation">
    
  <documentation>
    <title>Tanh</title>
    <authors>
      <author>Fabian Wein</author>
    </authors>
    <date>2015-07-30</date>
    <keywords>
      <keyword>SIMP</keyword>
    </keywords>
    <references>Wang and Sigmund; 2011</references>
    <isVerified>yes</isVerified>
    <description>See the descrition of solid_heavisde!
    The tanh is a generalization of solid Heaviside and void Heaviside by adding a parameter eta to shift inbetween.
    tanh can be used as a more configurate replacement of the Heavisde filters or as preparation for robustness.
    The idea is actually from the poor Xu paper "Volume preserving nonlinear density filter based on heaviside functions", 2010. However they
    didn't recognize that with eta=0.5 a checkerboard my persist according to Ole.
    Here the design gets more black and white than the original pyhsical density filtered design. However, the main purpose of tanh os for robustness.</description>
  </documentation>
    
  <fileFormats>
    <output>
      <hdf5/>
      <info/>
    </output>
    <materialData file="mat.xml" format="xml" />
  </fileFormats>

  <domain geometryType="plane">
    <regionList>
      <region material="99lines" name="mech" />
    </regionList>
  </domain>

  <sequenceStep index="1">
    <analysis>
      <static/>
    </analysis>

    <pdeList>
      <mechanic subType="planeStrain">
        <regionList>
          <region name="mech" />
        </regionList>

        <bcsAndLoads>
           <fix name="west"> 
              <comp dof="x"/> <comp dof="y"/> 
           </fix>
          <force name="right_lower">
              <comp dof="y" value="-1"/>
          </force>
        </bcsAndLoads>
        <storeResults>
          <nodeResult type="mechDisplacement">
            <allRegions />
          </nodeResult>
          <elemResult type="mechPseudoDensity">
            <allRegions/>
          </elemResult>          
          <elemResult type="physicalPseudoDensity">
            <allRegions/>
          </elemResult>             
          <regionResult type="mechDeformEnergy">
            <allRegions/>
          </regionResult>
       </storeResults>
      </mechanic>
    </pdeList>
  </sequenceStep>

  <loadErsatzMaterial file="bulk2d_20_nice.density.xml" set="last"/>

  <optimization>
    <costFunction type="compliance" task="minimize" multiple_excitation="false">
      <stopping queue="999" value="0.002" type="designChange" />
    </costFunction>

    <constraint type="volume" bound="upperBound" value="0.5" linear="false"/>

    <optimizer type="optimalityCondition" maxIterations="10">

    </optimizer>

    <ersatzMaterial region="mech" material="mechanic" method="simp">
      <filters>
        <filter neighborhood="maxEdge" value="1.9" type="density">
           <density type="tanh" beta="8" eta="0.5"/>
        </filter>
      </filters>

      <design name="density" initial="0.5" lower="1e-3" upper="1.0" />
      <transferFunction type="simp" application="mech"  param="3" />

      <export write="iteration" save="all" />

    </ersatzMaterial>
    <commit mode="each_forward" stride="1" />
  </optimization>
 
  
</cfsSimulation>


